package edu.berkeley.sbp.util;

/** miscellaneous string utilities */
public class StringUtil {

    public static String join(String[] s, String sep) {
        StringBuffer ret = new StringBuffer();
        for(int i=0; i<s.length; i++) {
            if (i>0) ret.append(sep);
            ret.append(s[i]);
        }
        return ret.toString();
    }
    public static String toJavaString(String s) {
        StringBuffer sb = new StringBuffer();
        for(int i=0; i<s.length(); i++) {
            char c = s.charAt(i);
            switch(c) {
                case '\\': sb.append("\\\\");  break;
                case '\"': sb.append("\\\"");  break;
                case '\'': sb.append("\\\'");  break;
                case '\n':  sb.append("\\n");  break;
                case '\r':  sb.append("\\r");  break;
                default: sb.append(c); break;
            }
        }
        return sb.toString();
    }

    public static String unescapify(String s) {
        StringBuffer sb = new StringBuffer();
        for(int i=0; i<s.length(); i++) {
            char c = s.charAt(i);
            if (c=='\\') {
                c = s.charAt(++i);
                switch(c) {
                    case 'r': c = '\r'; break;
                    case 'n': c = '\n'; break;
                    default: break;
                }
            }
            sb.append(c);
        }
        return sb.toString();
    }
    /*
                case ' ':  sb.append("\\ ");  break;
                case '{':  sb.append("\\{");  break;
                case '}':  sb.append("\\}");  break;
                case ':':  sb.append("\\:");  break;
    */
    public static String escapify(String s) { return escapify(s, "\\\n\r"); }
    public static String escapify(String s, String illegal) {
        StringBuffer sb = new StringBuffer();
        for(int i=0; i<s.length(); i++) {
            char c = s.charAt(i);
            if (illegal.indexOf(c) != -1)
                switch(c) {
                    case '\n':  sb.append("\\n"); continue;
                    case '\r':  sb.append("\\r"); continue;
                    default:    sb.append('\\');  break;
                }
            sb.append(c);
        }
        return sb.toString();
    }
}
